﻿using UnityEngine;
using System.Collections;

public class GamePlay : MonoBehaviour 
{
	private static GamePlay singleton = null;
	public static GamePlay getSingleton()
	{
		return singleton;
	}
	////////////////////////////////////////////////////////

	private string chatMessage;
	private int money_goal = 100 * 1000;
	private int money = 10000;
	private int luck = 0;
	private int day = 0;

	public int getLuck()
	{
		return luck;
	}

	public int getMaxLuck()
	{
		return 5;
	}

	public int getDay()
	{
		return day;
	}

	public int getMoney()
	{
		return money;
	}

	// Use this for initialization
	void Start() 
	{
		singleton = this;
	}

	void OnDestroy()
	{
		if (singleton == this)
		{
			singleton = null;
		}
	}
	
	// Update is called once per frame
	void Update ()
	{
		enabled = false;//hack
		scene_Welcome();
	}

	public void action_PlayGame(string arg)
	{
		scene_CasinoPeople();
	}

	public void action_CasinoChat(string who)
	{
		if (who == "Bob")
		{
			//chatMessage = "You talk to Bob, who says, \"I think that my blue underwear is lucky.\"";
			chatMessage = "You talk to Bob, who says, \"I think that my blue underwear is lucky.\"";
		}
		else if (who == "Jeff")
		{
			chatMessage = "You talk to Jeff, who says, \"I think that my Rabbits Foot charm is unlucky.\"";
		}
		else if (who == "Dylan")
		{
			chatMessage = "You talk to Dylan, who says, \"I think that hitting the Left Side of the Slot Machine is lucky.\"";
		}
		else if (who == "Aeries")
		{
			chatMessage = "You talk to Aeries, who says, \"Its funny watching all the crazy people and the rituals they concoct.\"";
		}
		else
		{
			chatMessage = "I'm sure I had something important to say, but I forgot what it was..."; //HACK
		}
		scene_CasinoInChat();
	}

	//public void action_FinishChatting(string arg)
	//{
		//TODO: stuff!
		//Debug.Log("cool story!");
	//}

	public void scene_CasinoPeople()
	{
		PanelDecisionTemplate pdt = PanelDecisionTemplate.getSingleton();
		PanelButtonsArray pba = PanelButtonsArray.getSingleton();
		Rooms.ClearScene();
		pba.clearButtons();

		/////////////////////////////////////////////////////////////////
		chatMessage = "";

		Rooms.ShowCasino();
		pba.addButton(new ButtonInfo("Talk With Bob", this.action_CasinoChat, "Bob"));
		pba.addButton(new ButtonInfo("Talk With Jeff", this.action_CasinoChat, "Jeff"));
		pba.addButton(new ButtonInfo("Talk With Dylan", this.action_CasinoChat, "Dylan"));
		pba.addButton(new ButtonInfo("Talk With Aeries", this.action_CasinoChat, "Aeries"));
		//pba.addButton(button);

		//pdt.SetImage("Prefabs/CharacterImages/Firefox_icon");
		//pdt.SetText("Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.");
		pdt.SetText("Chat with whom?");
	}

	public void scene_Welcome()
	{
		PanelDecisionTemplate pdt = PanelDecisionTemplate.getSingleton();
		PanelButtonsArray pba = PanelButtonsArray.getSingleton();
		Rooms.ClearScene();
		pba.clearButtons();

		/////////////////////////////////////////////////////////////////

		//Rooms.ShowCasino();
		
		
		//ButtonInfo button = new ButtonInfo("Hello", this.hello, "");
		//ButtonInfo button = new ButtonInfo("Play Game", this.action_PlayGame, "");
		//ButtonInfo button = new ButtonInfo("Play Game", this.action_PlayGame, "");
		pba.addButton(new ButtonInfo("Play Game", this.action_PlayGame, ""));
		//pba.addButton(new ButtonInfo("Play Game2", this.action_PlayGame, ""));
		//pba.addButton(new ButtonInfo("Play Game3", this.action_PlayGame, ""));
		//button);
		//pba.addButton(button);

		//pdt.SetImage("Prefabs/CharacterImages/Firefox_icon");
		//pdt.SetText("I heart IE6 ^ ^");
		day = 0;
		luck = -1000;
		money = 10000;
		pdt.SetText("Welcome to The Devil Went Down To Vegas!");//TeamBigMoney's Ritual GGJ2016 Game!");
	}

	//////////////////////////////////////////////////////////////////////////////////////////////////////

	public void scene_Morning()
	{
		PanelDecisionTemplate pdt = PanelDecisionTemplate.getSingleton();
		PanelButtonsArray pba = PanelButtonsArray.getSingleton();
		Rooms.ClearScene();
		pba.clearButtons();

		/////////////////////////////////////////////////////////////////

		Rooms.ShowBedroom("shower");//Q: show blackness?
		//TODO: show shower?
		pba.addButton(new ButtonInfo("Start your day", this.actionScene_Shower, ""));

		
		string msg = "You wake up. It is day "+day;
		if (day == 7)
		{
			msg += "\n" + "Reminder: this is the last day to earn enough money!"; //HACK!
		}
		pdt.SetText(msg);
	}

	public void actionScene_Shower(string arg)
	{
		PanelDecisionTemplate pdt = PanelDecisionTemplate.getSingleton();
		PanelButtonsArray pba = PanelButtonsArray.getSingleton();
		Rooms.ClearScene();
		pba.clearButtons();

		/////////////////////////////////////////////////////////////////

		Rooms.ShowBedroom("shower");//Q: show blackness?
		//TODO: show shower?
		pba.addButton(new ButtonInfo("Yes", this.actionScene_BrushTeeth, ""));
		pba.addButton(new ButtonInfo("No", this.actionScene_BrushTeeth, "lucky"));

		string msg = "Take a Shower?";
		/*if (day == 7)
		{
			msg += "\n" + "Reminder: this is the last day to earn enough money!"; //HACK!
		}*/

		pdt.SetText(msg);
	}

	void handleLuck(string luckResult)
	{
		if (luckResult == "lucky")
		{
			luck++;
		}
	}

	public void actionScene_BrushTeeth(string luckResult)
	{
		handleLuck(luckResult);
		PanelDecisionTemplate pdt = PanelDecisionTemplate.getSingleton();
		PanelButtonsArray pba = PanelButtonsArray.getSingleton();
		Rooms.ClearScene();
		pba.clearButtons();

		/////////////////////////////////////////////////////////////////

		Rooms.ShowBedroom("mirror");//Q: show blackness?
		//TODO: show shower?
		ButtonInfo.ButtonCallback callback = this.actionScene_pickUnderwear;
		pba.addButton(new ButtonInfo("Left", callback, "lucky"));
		pba.addButton(new ButtonInfo("Right", callback, ""));
		pdt.SetText("Start brushing your teeth on which side?");
	}

	public void actionScene_pickUnderwear(string luckResult)
	{
		handleLuck(luckResult);
		PanelDecisionTemplate pdt = PanelDecisionTemplate.getSingleton();
		PanelButtonsArray pba = PanelButtonsArray.getSingleton();
		Rooms.ClearScene();
		pba.clearButtons();

		/////////////////////////////////////////////////////////////////

		Rooms.ShowBedroom("dresser");//Q: show blackness?
		//TODO: show shower?
		ButtonInfo.ButtonCallback callback = this.actionScene_pickCharm;
		pba.addButton(new ButtonInfo("Blue", callback, "lucky"));
		pba.addButton(new ButtonInfo("Plaid", callback, ""));
		pdt.SetText("Wear what color underwear?");
	}

	public void actionScene_pickCharm(string luckResult)
	{
		handleLuck(luckResult);
		PanelDecisionTemplate pdt = PanelDecisionTemplate.getSingleton();
		PanelButtonsArray pba = PanelButtonsArray.getSingleton();
		Rooms.ClearScene();
		pba.clearButtons();

		/////////////////////////////////////////////////////////////////
		//@charm
		Rooms.ShowBedroom("dresser");//Q: show blackness?
		//TODO: show shower?
		ButtonInfo.ButtonCallback callback = this.actionScene_pickSideToTap;
		pba.addButton(new ButtonInfo("Rabbit's Foot", callback, ""));
		pba.addButton(new ButtonInfo("Troll Doll", callback, "lucky"));
		pdt.SetText("Use Which Charm?");
	}


	public void actionScene_pickSideToTap(string luckResult)
	{
		handleLuck(luckResult);
		PanelDecisionTemplate pdt = PanelDecisionTemplate.getSingleton();
		PanelButtonsArray pba = PanelButtonsArray.getSingleton();
		Rooms.ClearScene();
		pba.clearButtons();

		/////////////////////////////////////////////////////////////////

		Rooms.ShowBedroom("dresser");//Q: show blackness?
		//TODO: show shower?
		ButtonInfo.ButtonCallback callback = this.action_afterPickTap;
		pba.addButton(new ButtonInfo("Left", callback, "lucky"));
		pba.addButton(new ButtonInfo("Right", callback, ""));
		pdt.SetText("Which side of the slot machine will you plan to tap?");
	}

	void action_afterPickTap(string luckResult)
	{
		handleLuck(luckResult);
		//end of ritual!
		//fail://scene_CasinoInChat();
		scene_CasinoPeople();
	}
	//////////////////////////////////////////////////////////////////////////////////////////////////////


	public void scene_CasinoInChat()
	{
		PanelDecisionTemplate pdt = PanelDecisionTemplate.getSingleton();
		PanelButtonsArray pba = PanelButtonsArray.getSingleton();
		Rooms.ClearScene();
		pba.clearButtons();

		/////////////////////////////////////////////////////////////////

		Rooms.ShowCasino();
		//ButtonInfo button = new ButtonInfo("Cool Story Bro", this.action_FinishChatting, "");
		//ButtonInfo button = new ButtonInfo("Interesting.", this.action_FinishChatting, "");
		ButtonInfo button = new ButtonInfo("Continue to Slot Machines.", this.actionScene_FinishChatting, "");
		pba.addButton(button);
		pdt.SetText(""+this.chatMessage);
	}

	void actionScene_FinishChatting(string arg)
	{
		PanelDecisionTemplate pdt = PanelDecisionTemplate.getSingleton();
		PanelButtonsArray pba = PanelButtonsArray.getSingleton();
		Rooms.ClearScene();
		pba.clearButtons();

		/////////////////////////////////////////////////////////////////

		Rooms.ShowCasino();
		if (day > 0)
		{
			pba.addButton(new ButtonInfo("Penny Slots", this.actionScene_PlaySlots, "0"));
		}
		pba.addButton(new ButtonInfo("Expensive Slots", this.actionScene_PlaySlots, "5"));

		pdt.SetText("Play a slot machine?");
	}

	void actionScene_PlaySlots(string strRisk)
	{
		PanelDecisionTemplate pdt = PanelDecisionTemplate.getSingleton();
		PanelButtonsArray pba = PanelButtonsArray.getSingleton();
		Rooms.ClearScene();
		pba.clearButtons();

		/////////////////////////////////////////////////////////////////

		Rooms.ShowCasino();
		

		int amountEarned = 0;
		int risk = int.Parse(strRisk);

		//amountEarned = (p.luck - Math.floor(risk-1)) * Math.pow(10, risk);
		float rawEarn = (luck - (risk - 1)) * Mathf.Pow(10.0f, risk);
		amountEarned = (int)Mathf.Floor( rawEarn );
		if (day == 0)
		{
			amountEarned = -1000000;
			pdt.SetText("You lost One Million Dollars!!!");
			pba.addButton(new ButtonInfo("Return to Your Room", this.actionScene_DemonVisit, "5"));
		}
		else
		{
			string verb = "";
			string earnSign = "";
			if (amountEarned > 0)
			{
				verb = "earned";
			}
			else
			{
				earnSign = "-";
				verb = "lost";
			}//Q: show risk??
			//TODO: add commas...!?
			pdt.SetText("You " + verb + " " + earnSign + "$" + Mathf.Abs(amountEarned));
			pba.addButton(new ButtonInfo("Return to Your Room", this.action_EndOfDay, "5"));
		}
		money += amountEarned;
	}

	void actionScene_DemonVisit(string arg)
	{
		PanelDecisionTemplate pdt = PanelDecisionTemplate.getSingleton();
		PanelButtonsArray pba = PanelButtonsArray.getSingleton();
		Rooms.ClearScene();
		pba.clearButtons();

		/////////////////////////////////////////////////////////////////

		Rooms.ShowBedroom("demon");
		string nl = "\n";
		string msg = "";
		msg += "In despair, you head to your room. "+nl;
		msg += "In your room, a demon appears before you!"+nl;
		msg += "DEMON: To the fool who lost one million dollars by gambling while he had a disasterous luck:"+nl;
		msg += "I'll repay your debts if you can give me $100,000 by the end of the week,"+nl;
		msg += "... otherwise I'll take your soul!"+nl;
		pdt.SetText(msg);
		pba.addButton(new ButtonInfo("I accept", this.action_DemonZerosMoney, ""));
	
	}

	void action_DemonZerosMoney(string arg)
	{
		money = 0;
		action_EndOfDay(arg);
	}

	void action_EndOfDay(string arg)
	{
		luck = 0;
		day++;
		Debug.Log("day = " + day);
		if (day > 7)
		{
			scene_EndGame();
		}
		else
		{
			scene_Morning();
		}
	}

	void scene_EndGame()
	{
		PanelDecisionTemplate pdt = PanelDecisionTemplate.getSingleton();
		PanelButtonsArray pba = PanelButtonsArray.getSingleton();
		Rooms.ClearScene();
		pba.clearButtons();

		/////////////////////////////////////////////////////////////////
		//Q: demon?
		Rooms.ShowBedroom("demon");
		string msg = "You reach the end of the week, ";

		if (money < money_goal)
		{
			//msg += "and you are able to buy back your soul from the demon! YAY! \nGOOD END!";
			msg += "...and you are still short of money, so the demon steals your soul. \nBAD END!";
		}
		else
		{
			msg += "...and you are able to buy back your soul from the demon! YAY! \nGOOD END!";
		}

		pdt.SetText(msg);
		pba.addButton(new ButtonInfo("Replay", this.action_RestartGame, ""));
	}

	void action_RestartGame(string arg)
	{
		scene_Welcome(); //HACK!!
	}
}
