﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;

public class PanelButtons2DArray : MonoBehaviour {

    public List<List<GameObject>> button2DArray = new List<List<GameObject>>();
    private List<string> randomStringList = new List<string>() {"first", "second", "third", "fourth", "fifth", "sixth", "seventh", "eigth"};
    private string squareButtonsPath = "Prefabs/Buttons/Square";
    private int rows;
    private int cols;
    private float panelWidth;
    private float panelHeight;
    private RectTransform rectTransform;

    void Awake()
    {
        //rows = 4;
        cols = 3;
        //button2DArray = new List<List<Button>>();
        rectTransform = GetComponent<RectTransform>();
        panelWidth = rectTransform.sizeDelta.x;
        panelHeight = rectTransform.sizeDelta.y;
    }

	// Use this for initialization
	void Start ()
    {
        //LoadButtons();
        //InsertButtonText();
        //PlaceButtons();
	}

    void LoadButtons()
    {
        Object[] buttonPrefabs = Resources.LoadAll(squareButtonsPath, typeof(GameObject));
        foreach (GameObject newButton in buttonPrefabs)
        {
            rows++;
            button2DArray.Add(new List<GameObject>());
            if (newButton.gameObject.tag == "Square")    //checks if this is a square button
            {
                for (int i = 0; i < cols; i++)
                {
                    GameObject tempPrefab;
                    tempPrefab = Instantiate(newButton, new Vector3(transform.position.x, transform.position.y, transform.position.z), Quaternion.identity) as GameObject;
                    tempPrefab.gameObject.transform.SetParent(transform.parent);
                    button2DArray[button2DArray.Count - 1].Add(tempPrefab);
                }
            }
        }
    }

    void InsertButtonText()
    {
        for (int i = 0; i < button2DArray.Count; i++)
        {
            for(int j = 0; j < button2DArray[i].Count; j++)
            {
                button2DArray[i][j].GetComponentInChildren<Text>().text = randomStringList[Random.Range(0, randomStringList.Count)];
            }
        }
    }

    void PlaceButtons()
    {
        float tempWidth =  panelWidth / rows;
        float tempHeight = panelHeight / cols;
        Debug.Log(tempWidth + " " + tempHeight);
        for (int i = 0; i < rows; i++)
        {
            for (int j = 0; j < cols; j++)
            {
                button2DArray[i][j].GetComponent<RectTransform>().sizeDelta = new Vector2(tempWidth, tempHeight);
                button2DArray[i][j].GetComponent<RectTransform>().position = new Vector3((i * tempWidth) + (tempWidth * 0.5f), (j * tempHeight) + (tempHeight * 0.5f), button2DArray[i][j].GetComponent<RectTransform>().position.z);

            }
        }
    }
}
