﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;

public class PanelButtonsArray : MonoBehaviour 
{
	private static PanelButtonsArray singleton = null;

	public static PanelButtonsArray getSingleton()
	{
		return singleton;
	}

    public List<GameObject> buttonList = new List<GameObject>();
	private List<ButtonInfo> myButtons = new List<ButtonInfo>();
    private List<string> randomStringList = new List<string>() { "first", "second", "third", "fourth", "fifth", "sixth", "seventh", "eigth" };  //for testing purposes only
    private string buttonsPath = "Prefabs/Buttons/BlankButton";
    private int buttonTotal;
    private float panelWidth;
    private float panelHeight;
    private RectTransform rectTransform;
    private GameObject buttonPrefab;

    public List<ButtonInfo> buttonInfoList = new List<ButtonInfo>();

	void clickHandler(int buttonIndex)//UnityEngine.UI.Button.ButtonClickedEvent e)
	{
		//Debug.Log("index="+buttonIndex);//"e = " + e);//WTF
		myButtons[buttonIndex].invoke(); //VICTORY!!!
	}

	public void addButton(ButtonInfo info)
	{
		info = new ButtonInfo(info); //defensive copy
        //TODO:
		int buttonIndex = this.buttonTotal;
        buttonTotal++;
		GameObject button;
        button = Instantiate(buttonPrefab, new Vector3(transform.position.x, transform.position.y, transform.position.z), Quaternion.identity) as GameObject;
        button.GetComponent<RectTransform>().localScale = new Vector3(1.0f, 1.0f, 1.0f);
        button.gameObject.transform.SetParent(this.rectTransform);
		//UnityEngine.UI.Button.ButtonClickedEvent bce = new Button.ButtonClickedEvent();
		PanelButtonsArray self =this;
		
		//bce.AddListener( delegate()
        //           { self.clickHandler(buttonIndex); });
		//button.GetComponent<Button>().onClick += bce;// this.clickHandler;
		button.GetComponent<Button>().onClick.AddListener(delegate()
		{ 
			self.clickHandler(buttonIndex); 
		});
		button.transform.GetChild(0).gameObject.GetComponent<Text>().text = info.buttonText; //MAGICAL HACK OF VICTORY2.0!!!

		buttonList.Add(button);
        buttonInfoList.Add(info);
		myButtons.Add(info);
        PlaceButtons();
    }

	public void clearButtons()
	{
		myButtons.Clear();
		//TODO
        for(int i = 0; i < buttonList.Count; i++)
        {
            Destroy(buttonList[i]);
        }
        buttonList = new List<GameObject>();
        for(int j = 0; j < buttonInfoList.Count; j++)
        {
            buttonInfoList[j] = null;
        }
        buttonInfoList = new List<ButtonInfo>();
        buttonTotal = 0;
	}


	
    void Awake()
    {
        //button2DArray = new List<List<Button>>();
        rectTransform = GetComponent<RectTransform>();
        panelWidth = rectTransform.sizeDelta.x;
        panelHeight = rectTransform.sizeDelta.y;
    }

    // Use this for initialization
    void Start()
    {
		singleton = this;
        LoadButtonPrefab();
        //addButton();
        InsertButtonText();
        //PlaceButtons();

    }

	void OnDestroy()
	{
		if (singleton == this)
		{
			singleton = null;
		}
	}

    void SetButtonsPath(string newPath)
    {
        buttonsPath = newPath;
    }

	//public static void OnClick()

    void LoadButtonPrefab()
    {
        /*
        buttonTotal = 0;
        Object[] buttonPrefabs = Resources.LoadAll(buttonsPath, typeof(GameObject));
        foreach (GameObject newButton in buttonPrefabs)
        {
            buttonTotal++;
            GameObject tempPrefab;
            tempPrefab = Instantiate(newButton, new Vector3(transform.position.x, transform.position.y, transform.position.z), Quaternion.identity) as GameObject;
            tempPrefab.GetComponent<RectTransform>().localScale = new Vector3(1.0f, 1.0f, 1.0f);
            tempPrefab.gameObject.transform.SetParent(this.rectTransform);
                
            buttonArray.Add(tempPrefab);
        }*/
        
        buttonPrefab = Resources.Load<GameObject>(buttonsPath);
        Debug.Log("Prefab name is " + buttonPrefab.name);
    }

    void InsertButtonText(string [] newArray = null)
    {
        if (newArray == null)
        {
            for (int i = 0; i < buttonList.Count; i++)
            {
                buttonList[i].GetComponentInChildren<Text>().text = randomStringList[Random.Range(0, randomStringList.Count)];
            }
        }
        else
        {
            for (int i = 0; i < newArray.Length; i++)
            {
                buttonList[i].GetComponentInChildren<Text>().text = newArray[i];
            }
        }
    }

    void PlaceButtons()
    {
        float tempHeight = rectTransform.sizeDelta.y;
        float tempWidth = rectTransform.sizeDelta.x / buttonTotal;
        for (int i = 0; i < buttonTotal; i++)
        {
            RectTransform tempRectTransform = buttonList[i].GetComponent<RectTransform>();
            tempRectTransform.localScale = new Vector3(1.0f, 1.0f, 1.0f);
            tempRectTransform.sizeDelta = new Vector2(tempWidth, tempHeight);
            tempRectTransform.localPosition = new Vector3((i * tempRectTransform.sizeDelta.x) - ((buttonList.Count * 0.5f) * tempRectTransform.sizeDelta.x) + (tempRectTransform.sizeDelta.x * 0.5f), 0.0f, 0.0f);
        }
    }
}