﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;

public class PanelDecisionTemplate : MonoBehaviour 
{
	private static PanelDecisionTemplate singleton = null;

	public static PanelDecisionTemplate getSingleton()
	{
		return singleton;
	}

    //public List<GameObject> button2DArray = new List<GameObject>();
    private List<string> randomStringList = new List<string>() { "first", "second", "third", "fourth", "fifth", "sixth", "seventh", "eigth" };
    private string squareButtonsPath = "Prefabs/Buttons/Square";
    private string imagePath = "Prefabs/CharacterImages";
    private int buttonTotal;
    private float panelWidth;
    private float panelHeight;
    private RectTransform rectTransform;
    private Image image;
    private Text text;
    private RectTransform buttonsPanel;


    void Awake()
    {
        //button2DArray = new List<List<Button>>();
        rectTransform = GetComponent<RectTransform>();
        image = transform.Find("ProfileImage").GetComponent<Image>();
        text = transform.Find("CharacterText").GetComponent<Text>();
        buttonsPanel = transform.Find("ButtonsPanel").GetComponent<RectTransform>();
        panelWidth = rectTransform.sizeDelta.x;
        panelHeight = rectTransform.sizeDelta.y;
    }

    // Use this for initialization
    void Start()
    {
		singleton = this;
        SetImage();//"Prefabs/CharacterImages/SublimeText_icon");
        SetText();
        ///LoadButtons();
        //InsertButtonText();
        //PlaceButtons();
    }

	void OnDestroy()
	{
		if (singleton == this)
		{
			singleton = null;
		}
	}

    public void SetImage(string newImage = null)
    {
        if(newImage == null)
        {
            Object[] images = Resources.LoadAll(imagePath, typeof(Sprite));
            image.sprite = images[Random.Range(0, images.Length)] as Sprite;
        }
        else
        {
            image.sprite = Resources.Load<Sprite>(newImage);
            Debug.Log("Trying to load " + newImage);
        }
    }

    public void SetText(string newText = null)
    {
        if(newText == null)
        {
            text.text = "This is placeholder text";
        }
        else
        {
            text.text = newText;
        }
    }
}
