﻿using UnityEngine;
using System.Collections;

public class Scene3DController : MonoBehaviour 
{
	public GameObject[] cameras;

	private static Scene3DController singleton = null;
	public static Scene3DController getSingleton()
	{
		return singleton;
	}

	void Start () 
	{
		singleton = this;	
	}
	
	void OnDestroy()
	{
		if (singleton == this)
		{
			singleton = null;
		}
	}

	public void setCamera(int index)
	{
		GameObject useCamera = this.cameras[index];
		setCamera(useCamera);
	}

	public void setCamera(GameObject camera)
	{
		for(int i=0; i<this.cameras.Length; i++)
		{
			cameras[i].SetActive(cameras[i] == camera);
		}
	}

	public void showObject(string prefabName, float x, float z, float theta)
	{//also for showbg
		Object rc = Resources.Load(prefabName);
		if (rc == null)
		{
			Debug.LogError("resource null for prefab: " + prefabName);
		}
		GameObject go = (GameObject)GameObject.Instantiate(rc);
		Transform t = go.transform;
		t.position = new Vector3(x, 0, z);
		//t.rotation = Quaternion.Euler(0, theta, 0);
		t.rotation = Quaternion.Euler(0,theta, 0);

		t.parent = transform;
	}

	public void destroyObjects()
	{
		Transform t = this.transform;
		for(int i=0; i<t.childCount; i++)
		{
			GameObject go = t.GetChild(i).gameObject;
			GameObject.Destroy(go);
		}
	}
}
